<?php

/**
 This project has been generated by nuts generator
 nuts has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 */


namespace Model;
use Base\BaseModel;
use Handler\DataValidationException;

class TransactiondebitModel extends BaseModel
{
    protected $table="transactiondebit";

    protected $aliasTable="transd";

    	protected $primaryKey="id";
	protected $fillable=["accountBankId","familyId","transactionId"];

    		public function joinRelationAccountbank($alias = "accountbank"){
			$this->query->join("accountbank as $alias","$alias.id","=","transd.accountBankId");
		return $this;
		}
		public function joinRelationFamily($alias = "family"){
			$this->query->join("family as $alias","$alias.id","=","transd.familyId");
		return $this;
		}
		public function joinRelationTransaction($alias = "transaction"){
			$this->query->join("transaction as $alias","$alias.id","=","transd.transactionId");
		return $this;
		}


    		public function beforeEnterIntoDatabase(){
			if(empty($this->accountBankId)){
			throw new DataValidationException("accountBankId cannot be null");
		}
if(empty($this->familyId)){
			throw new DataValidationException("familyId cannot be null");
		}
if(empty($this->transactionId)){
			throw new DataValidationException("transactionId cannot be null");
		}
			$Accountbank= (new \Model\AccountbankModel)->findById($this->accountBankId);
			if(empty($Accountbank)){
			throw new DataValidationException("accountBankId Invalid Relation ID");
	}
			$Family= (new \Model\FamilyModel)->findById($this->familyId);
			if(empty($Family)){
			throw new DataValidationException("familyId Invalid Relation ID");
	}
			$Transaction= (new \Model\TransactionModel)->findById($this->transactionId);
			if(empty($Transaction)){
			throw new DataValidationException("transactionId Invalid Relation ID");
	}
		return $this;
}
}